;*********************************
;*  Viewer hxadcimal pour Ti89 *
;*  Version 1.5                  *
;*********************************
;Lurdos Olivier
;OLURDOS@Wanadoo.fr

	include "Doorsos.h"
	include "Util.h"
	include "GraphLib.h"
	include "UserLib.h"
	xdef _ti89
	xdef _main
	xdef _comment


;********************
;*  Sous-programme  *
;********************
AffichHex:
;--------
	;input	d0.b = nb  afficher
	;	d1.w = x
	;	d2.w = y
	;affiche le nombre au format hxadcimal  la position (x,y)
	; d0 dtruit, d1,d2 reste intact
	and.l	#$FF,d0
	divu	#16,d0		;1symbole d0=d0/16
	move.w	#4,-(a7)	;On prpare la pile pour le 2 appel
	move.w	d2,-(a7);y
	move.w	d1,-(a7);x
	bsr	GetCode
	move.w	d0,-(a7)

	rol.l	#8,d0		;on met le reste dans d0
	rol.l	#8,d0
	bsr	GetCode
	add	#6,d1
	move.w	#4,-(a7)	;Affichage du 2 symbole
	move.w	d2,-(a7);y
	move.w	d1,-(a7);x
	move.w	d0,-(a7)
	jsr	util::DrawCharXY	;Affichage 2symbole
	lea	8(a7),a7
	jsr	util::DrawCharXY	;Affichage 1symbole
	add.l	#2,a7			;On restore d1,d2 et la pile
	move.w	(a7)+,d1
	move.w	(a7)+,d2
	add.l	#2,a7
	rts

	GetCode:
	;input	d0.b = code hex
	;output	d0.w = code du caractre correspondant
	;les deux bits de poids forts de d0.l ne sont pas dtruits
	sub.b	#10,d0
	bmi	\GcNb
	add	#7,d0	;-10+7+58=55
	\GcNb:
	add	#58,d0	;-10+58=48 <=> "0"
	rts

AffichHex2:
;---------
	;input	d0.l = nb  afficher
	;	d1.w = x
	;	d2.w = y
	;affiche le nombre au format hxadcimal  la position (x,y)
	;registre d3 dtruit
	move.w	#3,d3
	move.l	d0,-(a7)
	\AffHex2Loop:
	move.l	(a7)+,d0
	rol.l	#8,d0
	move.l	d0,-(a7)
	bsr	AffichHex
	add	#12,d1
	dbeq	d3,\AffHex2Loop
	add.l	#4,a7
	rts

InputHex:
;-------
	;input  d1.w = x
	;	d2.w = y
	;	d3.w = MaxChar
	;Output	d0.l = Nb hxa que l'utilisateur  entrer
	;       d1.w = 1 si l'utilisateur  appuyer sur entrer
	;	       0         "       "       "      ESC
	;L'utilisateur entre un nombre au format Hex  la position x,y

	jsr	userlib::InputStr
	cmp	#0,d0	;d0 = NbChar ou 0 si ESC/aucun caractre enfonc
	beq	\IhEsc
	sub.l	#1,d0
	move.l	#0,d1	;d1=nombre  retouner

	\loop:
	lsl.l	#4,d1	;d2=d2*16
	move.b	(a0)+,d2
	bsr	GetCodeHex
	add.l	d2,d1
	dbeq	d0,\loop
	move.l	d1,d0
	move.l	#1,d1
	rts

	\IhEsc:
	move.l	#0,d1
	rts

GetCodeHex:
	;input	d2.b=code de la touche
	;output	d2.b=code hxa. correspondant
	;	"0" <=> 0  ...	"1" <=> 1
	;	"A" <=> 10 ...	"F" <=> 15
	;	"a" <=> 10 ...	"f" <=> 15
	sub.b	#102,d2		;102 <=> "f"
	bgt	\GchNo
	add.b	#5,d2		;97 <=> "a"
	bge	\Lettr
	add.b	#27,d2		;70 <=> "F"
	bgt	\GchNo
	add.b	#5,d2		;65 <=> "A"
	bge	\Lettr
	add.b	#8,d2		;57 <=> "9"
	bgt	\GchNo
	add.b	#9,d2		;48 <=> "0"
	bge	\Nb
	bra	\GchNo
	\Lettr:	add.b	#10,d2
	\Nb:	rts
	\GchNo:	clr.b	d2
		rts

Cherche:			;boucle "search"
;-------
	;input	a0.l=adresse de dbut
	;	d0.b=bit  chercher
	;output	a0 = adresse trouve
	move.b		d0,-(a7)
	move.l		a0,-(a7)
	jsr		util::zap_screen
	WriteStr	#0,#10,#4,sc3
	move.l		(a7)+,a0
	move.b		(a7)+,d0

	\ch:
	move.b	(a0)+,d1
	cmp.b	d0,d1
	beq	\Chfind
	bra	\ch

	\Chfind:
	sub.l	#1,a0
	rts


;**********
;*  Main  *
;**********
_main:
	move.l	#0,adr
deb:
	jsr		util::zap_screen
	WriteStr	#0,#0,#4,StrAdr		;affiche "Addresse:"
	move.w		#0,-(a7)		;change la font
	jsr		doorsos::FontSetSys
	WriteStr	#10,#92,#4,StrAide	;affiche "Aide : [F1]"
	move.w		#1,-(a7)
	jsr		doorsos::FontSetSys
	lea		4(a7),a7

	move.w	#111,d0		;ligne verticale
	move.w	#8,d1
	move.w	#90,d2
	jsr	graphlib::vert
	move.w	#0,d0	;x1	ligne horizontale (haut)
	move.w	#8,d1	;y
	move.w	#160,d2	;x2
	move.w	#2,d3	;couleur
	jsr	graphlib::horiz
	move.w	#90,d1		;ligne horizontale (bas)
	jsr	graphlib::horiz

	move.l	adr,d0		;affichage de l'adresse
	move.w	#60,d1 ;x
	move.w	#0,d2  ;y
	bsr	AffichHex2



		;d5=compteur colonne
		;d6=compteur ligne
	move.l	adr,a5
	move.w	#10,d2		;y
	move.w	#7,d6		;compteur ligne
	\ligne:				;dbut boucle ligne

	move.l	a5,a6
	move.w	#7,d5	;compteur colonne = 8
	move.w	#0,d1    ;x
	\AffHex:		;dbut boucle Hex
	move.b	(a6)+,d0	;(Affichage des codes hex)
	bsr	AffichHex
	add	#14,d1
	dbeq	d5,\AffHex	;fin boucle Hex

	move.l	a5,a6
	move.w	#7,d5		;compteur colonne = 8
	move.w	#4,-(a7)	;prparation de la pile
	move.w	d2,-(a7)
	move.w	d1,-(a7)
	\AffCar:
	move.b	(a6)+,d0
	move.w	d0,-(a7)
	jsr	util::DrawCharXY
	add.l	#2,a7
	add	#6,(a7)	;x=x+6
	dbeq	d5,\AffCar	;fin boucle AffCar
	add.l	#2,a7
	move.w	(a7),d2		;on restore y=d2
	add.l	#4,a7
	
	add	#10,d2	;y=y+10
	add.l	#8,a5
	dbeq	d6,\ligne


	jsr	util::idle_loop
	clr.l	d1
	cmp	#338,d0		;gauche
	beq	gauche
	cmp	#344,d0		;droite
	beq	droite
	cmp	#340,d0		;code bas
	beq	bas
	cmp	#4436,d0	;code shift+bas
	beq	shbas
	cmp	#16724,d0	;code diamond+bas
	beq	dmbas
	cmp	#337,d0		;code haut
	beq	haut
	cmp	#4433,d0	;code shift+haut
	beq	shhaut
	cmp	#16721,d0	;code diamond+haut
	beq	dmhaut
	cmp	#264,d0		;code ESC => Fin
	beq	fin

	cmp	#268,d0		;code F1 - Aide
	beq	f1
	cmp	#269,d0		;code F2 - Nouvelle Adresse
	beq	f2
	cmp	#270,d0		;code F3 - Chercher
	beq	f3
	cmp	#271,d0		;code F4 - Chercher encore
	beq	f4
	cmp	#272,d0		;code F5 - About
	beq	f5
	bra	deb
fin:	rts

dmhaut:	move.l	#$FC0,d1	;$FC0+$30+$F+$1=$1000
shhaut:	add.l	#$30,d1		;$30+$F+$1=$40
haut:	add.l	#$F,d1		;$F+$1=$10
gauche:	add.l	#1,d1
	sub.l	d1,adr
	bra	deb
dmbas:	move.l	#$FC0,d1
shbas:	add.l	#$30,d1
bas:	add.l	#$F,d1
droite:	add.l	#1,d1
	add.l	d1,adr
	bra	deb

;******************************************
f1:
	jsr		util::zap_screen
	WriteStr	#0,#0,#4,id1
	WriteStr	#0,#10,#4,id2
	WriteStr	#42,#20,#4,id3
	WriteStr	#0,#30,#4,id4
	WriteStr	#0,#40,#4,id5
	WriteStr	#0,#50,#4,id6
	WriteStr	#6,#60,#4,id7
	jsr		util::idle_loop
	bra		deb

;******************************************
f2:
	jsr		util::zap_screen
	WriteStr	#0,#10,#4,StrHex
	WriteStr	#0,#20,#4,StrHex2

	move.w	#10,d1
	move.w	#35,d2
	move.w	#8,d3
	bsr	InputHex
	cmp	#1,d1
	beq	\f2OK
	bra	deb
	\f2OK:
	move.l	d0,adr
	bra	deb

;******************************************
f3:
	jsr	util::zap_screen
	WriteStr	#0,#10,#4,sc1
	WriteStr	#0,#20,#4,sc2

	move.w	#10,d1
	move.w	#35,d2
	move.w	#2,d3
	bsr	InputHex
	cmp	#1,d1
	beq	\f3OK
	bra	deb
	\f3OK:
	move.b	d0,search
	move.l	adr,a0
	bsr	Cherche
	move.l	a0,adr
	bra	deb

;******************************************
f4:
	jsr	util::zap_screen
	move.l	adr,a0		;on ajoute 1  l'adresse
	add.l	#1,a0
	move.b	search,d0
	bsr	Cherche		;puis on continue la recherche
	move.l	a0,adr
	bra	deb

;******************************************
f5:
	jsr		util::zap_screen
	WriteStr	#0,#0,#4,ab1
	WriteStr	#0,#20,#4,ab2
	WriteStr	#0,#40,#4,ab3
	WriteStr	#0,#50,#4,ab4
	jsr		util::idle_loop
	bra		deb


;***************
;*  Variables  *
;***************
_comment:
	dc.b	"Viewer hwadcimal - Version 1.5"

adr	dc.l	0

search	dc.b	0

StrAdr	dc.b	"Adresse :",0
StrAide	dc.b	"Aide = [F1]  -  Quitter = ESC",0

id1	dc.b	"[F1] = Aide",0			;Ecran d'aide
id2	dc.b	"[F2] = Aller  une",0
id3	dc.b	"nouvelle addresse",0
id4	dc.b	"[F3] = Rechercher",0
id5	dc.b	"[F4] = Chercher encore",0
id6	dc.b	"[F5] = About",0
id7	dc.b	"ESC = Quitter",0

StrHex	dc.b	"Entrez l'adresse",0		;Ecran nouvelle adresse
StrHex2	dc.b	"hexadcimale :",0

sc1	dc.b	"Entrez le code hxadcimal",0	;Ecran Chercher
sc2	dc.b	"a chercher :",0
sc3	dc.b	"Recherche en cours",0

ab1	dc.b	"HxView89 - Version 1.5",0	;Ecran About
ab2	dc.b	"Lurdos Olivier",0
ab3	dc.b	"En cas de bugs :",0
ab4	dc.b	"OLURDOS@Wanadoo.fr",0
	end